function ApiConnector(){
    if(arguments.callee._singletonInstance){
	    return arguments.callee._singletonInstance;
	}
	arguments.callee._singletonInstance = this;

	var self = this; self.name = "ApiConnector"; // MANDATORY

    this.protocol = "https://";
    this.secure_connection = true;
    this.player_id = 0;
    
    this.setCoreId = function(id){
      if(typeof(id) !== "undefined"){
        if(!isNaN(parseInt(id))){
          self.player_id = parseInt(id);
        }
      }
    }
    
    this.setSecureConnection = function(activate){
      if(typeof(activate) === "boolean"){
        self.secure_connection = activate;
      }
      if(self.secure_connection){
        self.protocol = "https://";
      }else{
        self.protocol = "http://";
      }
    }

    this.buildUrl = function(api_url,api_ver,method){
        return self.protocol +api_url + "/" + api_ver + "/" + method;
    };

    this.post = function(api_url,api_ver,method, data, callback, params){
        var url = self.buildUrl(api_url,api_ver,method);
        self.makeRequest("POST",url, function(response, status){
            if(typeof(callback) !== "undefined"){
                try{
                    callback(JSON.parse(response),status,params);
                }catch(e){
                    callback(response,status,params);
                }
            }
        },data);
        url = null;
    };

    this.get = function(api_url,api_ver,method, data, callback, params){
        var url = self.buildUrl(api_url,api_ver,method);
        self.makeRequest("GET",url+"/"+data,function(response, status){
            if(typeof(callback) !== "undefined"){
                try{
                    callback(JSON.parse(response),status,params);
                }catch(e){
                    callback(response,status,params);
                }
            }
        });
        url = null;
    };

    this.makeRequest = function(method,url,callback,data){
        var xhr = new XMLHttpRequest();
        url = url+"?"+Date.now();
        xhr.open(method, url, true);
        xhr.setRequestHeader("From", "player-"+self.player_id);
        if(typeof(data) === "object"){
            data = JSON.stringify(data);
            xhr.setRequestHeader('Content-Type', 'application/json; charset=utf-8');
        }else{
            xhr.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded; charset=utf-8');
        }
        xhr.addEventListener("load", function () {
            if(xhr.status === 200 || xhr.status === 0){
                callback(xhr.response,"success");
            }
        }, false);
        /*
        xhr.addEventListener("progress", function (e) {
            if(e.lengthComputable){
                var percent = (e.loaded / e.total) * 100;
                console.log(percent+" % of "+e.total+" bytes");
            }
        }, false);
        */
        xhr.addEventListener("error", function (e) {
            //self.log("XML Loading Error for: "+url);
            callback(null,"error");
        }, false);
        if(typeof(data) !== "undefined"){
            xhr.send(data);
        }else{
            xhr.send();
        }
    }
}
