function TransferService(){
    if(arguments.callee._singletonInstance){
	    return arguments.callee._singletonInstance;
	}
	arguments.callee._singletonInstance = this;

	var self = this; self.name = "TransferService"; // MANDATORY

    this.license = new RegisterService();
    this.file_manager = new FileManagerService();

    this.analytic = false;

    this.xml_timestamp = 0;

    this.screenshot = false;
    this.screenshot2 = false;
    this.no_screenShot = false;

    this.hardware_info = "";
    this.bundle = "0";
    this.pass = 0;

    this.alive_interval = 20000;
    this.live_interval = 25000;
    this.library_interval = 33000;
    this.errors_interval = 60000;

    this.alive_timer = 0;
    this.library_timer = 0;
    this.live_timer = 0;
    this.errors_timer = 0;

    this.timeChecked = false;
    this.timeCheckRetries = 0;

    this.initiated = false;
    //this.started = false;

    this.setTimeCallback = false;

    this.player_version = "";

    this.reading_errors = false;
    this.sendTimers = false;

    this.init = function(player_version,force_platform){
        //var test = this.isgoingtofail(); //<-- MAKE PLAYER FAIL !! TEST !!!
        self.player_version = player_version;
        if(!self.initiated){
            self.initiated = true;
            self.setPlatform(force_platform);
            self.OS.init(self.start);
        }else{
            self.notifyError(self.ERROR['TRANSFER_SERVICE']+16,self.name+": Warning ... Transfer already initated ¿? ... set started = true");
            self.started = true;
        }
    };

    this.start = function(){

        self.OS.readFile(self.ROUTES['CORE'].path,self.initialCore);

    };

    this.initialCore = function(data){
        self.started = true;
        if(data !==  ""){
            self.setAPIroutes(data);
            self.ROUTES['CORE'].exists = true;
            if(self.platform == "SOC" || self.platform == "WEBOS"){
                self.log("No need for config file");
            }else{
                self.OS.readFile(self.ROUTES['CONFIG'].path,self.initialConfig);
            }
        }else{
            self.notifyError(self.ERROR['TRANSFER_SERVICE']+16,self.name+": Function initialCore()  :  started: "+self.started);
        }
    };

    this.initialConfig = function(data){
        if(data !==  ""){
            self.setPaths(data);
            self.started = true;
        }else{
            self.notifyError(self.ERROR['TRANSFER_SERVICE']+16,self.name+": Function initialConfig()  :  started: "+self.started);
        }
    };


    this.update = function(timestamp,archive){
        if(self.platform == "WIN" || self.platform == "LINUX" || self.platform == "MAC"){
            self.timeChecked = true;
        }else{
            self.timeChecked = false;
        }
        self.xml_timestamp = timestamp;

        self.file_manager.update();

        setTimeout(function(){self.OS.getInfoSystem();},5000);

        if(!self.alive_timer){
            self.alive();
        }
        if(!self.library_timer){
            self.library();
        }
        if(!self.errors_timer){
            self.check_errors();
        }
        if(!self.live_timer){
            self.live();
        }

        if(!self.analytic){
            self.analytic = new StatisticService();
            self.analytic.init();
        }
    };

    this.alive = function(){
        clearTimeout(self.alive_timer);
        if(!self.OS.busy){
          self.internet_connected = self.OS.internetConnected();
          if(self.platform != "SOC"){
            self.internet_connected = true;
          }
          if(self.internet_connected && self.started){
              self.log("# Alive beat ... ");
              if(!self.license.registered){
                  self.license.register(self.onRegisterComplete);
              }else{
                  // TODO:
                  // Check Status
                  // Hardware Info Check

                  // Send Alive
                  if(self.platform != "SOC"){
                      if(self.bundle == "0"){
                          self.OS.readFile(self.ROUTES['VER'].path,function(data,file_ref,params){
                        	  self.log("bundle------------------------------------------------------------- "+data);
                              if(data != "" && self.bundle != data){
                                  self.bundle = data;
                              }
                          });
                      }
                  }

                  var data = self.getAliveData();
                  self.log("Sending alive for player : "+self.core_id+" Using protocol : "+self.api_connector.protocol);
                  //self.log(JSON.stringify(data));
                  self.api_connector.post(self.api_url,self.api_ver,"player/alive",data,self.aliveResponse);

                  if(!self.timeChecked){
                  self.api_connector.get(self.api_url,self.api_ver,"player/timezone/id",self.core_id,self.serverDateTimeResponse);

                  }

                  self.OS.getNetworkInfo(function(info){
                      if(typeof(info.ip) !== "undefined"){
                          self.local_ip = info.ip;
                      }
                  });
              }
          }else{
              self.log("# Alive beat ... started: "+self.started+" internet : "+self.internet_connected);
              //self.notifyError(self.ERROR['TRANSFER_SERVICE']+2,self.name+": Function alive()  :  started: "+self.started+" internet : "+self.internet_connected);
          }
          self.alive_timer = setTimeout(self.alive,self.alive_interval);
        }else{
            self.alive_timer = setTimeout(self.alive,5000);
            self.log("# Alive beat ... CANCELED ... OS is busy");
        }
    };

    this.onRegisterComplete = function(){
        self.alive();
    };

    this.aliveResponse = function(response,status,params){
        if(status == "success"){
            try{
                var newTstamp = "";
                if(typeof(response.week) !== "undefined"){
                    newTstamp = ""+response.week;
                }else{
                    newTstamp = ""+response.xml_week;
                }
                if(self.xml_timestamp != newTstamp){
                    self.log("Pending download XML : "+self.xml_timestamp+" != "+newTstamp);
                    if(!self.file_manager.downloading){
                        self.file_manager.downloadDataXML(newTstamp,self.onPlaylistDownloaded,self.onPlaylistDownloadedError);
                    }
                    else{
                        self.file_manager.checkDataXML(newTstamp,self.onPlaylistDownloaded);
                    }
                }else{
                    self.log("No need to download XML : "+self.xml_timestamp+" == "+newTstamp);
                }
                if(typeof(response.no_screenShot) !== "undefined"){
                    if(self.no_screenShot != response.no_screenShot){
                        if(response.no_screenShot == true){
                            self.log("TurnOn no_screenShot.");
                            self.live_interval = 86400000;
                            clearTimeout(self.live_timer);
                            self.live_timer = null;
                            self.no_screenShot = true;
                            self.OS.superEco = true;
                        }
                        else{
                            self.OS.superEco = false;
                            self.no_screenShot = false;
                            if(typeof(response.live_interval) !== "undefined"){
                                if(response.live_interval != self.live_interval && response.live_interval >= 25000){
                                    self.log("Changing live interval to  : "+response.live_interval);
                                    self.OS.eco = true;
                                    self.live_interval = parseInt(response.live_interval);
                                    clearTimeout(self.live_timer);
                                    self.live_timer = setTimeout(self.live,self.live_interval);
                                }
                                else{
                                    self.live_interval = response.live_interval;
                                    clearTimeout(self.live_timer);
                                    self.live_timer = setTimeout(self.live,response.live_interval);
                                }
                            }
                        }
                    }
                    else{
                        if(typeof(response.live_interval) !== "undefined"){
                            if(response.live_interval != self.live_interval && response.live_interval >= 25000){
                                self.log("Changing live interval to  : "+response.live_interval);
                                self.OS.eco = true;
                                self.live_interval = parseInt(response.live_interval);
                                clearTimeout(self.live_timer);
                                self.live_timer = setTimeout(self.live,self.live_interval);
                            }
                        }
                    }
                }
                else{
                    if(typeof(response.live_interval) !== "undefined"){
                        if(response.live_interval != self.live_interval && response.live_interval >= 25000){
                            self.log("Changing live interval to  : "+response.live_interval);
                            self.OS.eco = false;
                            self.live_interval = parseInt(response.live_interval);
                            clearTimeout(self.live_timer);
                            self.live_timer = setTimeout(self.live,self.live_interval);
                        }
                    }
                }
                if(self.OS.eco == true || self.OS.superEco == true){
                    self.intervalManagement = 120000;
                }
                else{
                    self.intervalManagement = 20000;
                }
            }catch(e){
                self.log("Error reading Alive response : " + e);
                self.notifyError(self.ERROR['TRANSFER_SERVICE']+3,self.name+": Function aliveResponse() failed : Error reading Alive response ... ");
                self.log(response);
            }
        }else{
            self.notifyError(self.ERROR['TRANSFER_SERVICE']+15,self.name+": Function aliveResponse() failed : request status not success = "+status);
        }
        self.license.checkApiKey();
        //self.screenshot = "";

    };

    this.getAliveData = function(){
        var playlist_status = {
                id: "status",
                player:self.core_id,
                name: "PlaylistController"
            };
        self.getStatusFile(playlist_status,function(data,params){
            if(typeof(data) !== "undefined"){
                if(typeof(data.pass) !== "undefined"){
                    if(!isNaN(data.pass)){
                        self.pass = data.pass;
                    }
                }
            }
        });
        var data = {
            id: self.core_id,
            status: 1,
            content_id : self.OS.id_content_now,
            xml_day: self.xml_timestamp,
            xml_timestamp: self.xml_timestamp,
            xml_week: self.xml_timestamp,
            system: self.platform,
            vtransfer: self.version,
            vplayer: self.player_version,
            bundle: self.bundle,
            pase: self.pass
        }
        if(self.OS.dataInfoSystem != null && self.OS.sendInfoSystem == false){
            data.dataInfoSystem = self.OS.dataInfoSystem;
            self.OS.sendInfoSystem = true;
        }
        self.log(JSON.stringify(data));
        if(self.no_screenShot == true){
            if(self.OS.screenshotServer != null){
                data.sc = self.OS.screenshotServer;
                self.OS.screenshotServer = null;
            }
            else{
                data.sc = "";
            }
        }
        else{
            data.sc = self.screenshot;
            self.screenshot = "";
        }
        return data;
    };

    this.onPlaylistDownloaded = function(ok,params){
        if(ok){
            if(typeof(params) !== "undefined"){
                if(typeof(params.xml_timestamp) !== "undefined"){
                    self.xml_timestamp = params.xml_timestamp;
                }
            }
        }else{
            self.log("Problem downloading or unzipping playlist data : ");
            self.notifyError(self.ERROR['TRANSFER_SERVICE']+4,self.name+": Function onPlaylistDownloaded() failed : Problem downloading or unzipping playlist data file ");
        }
    };

    this.onPlaylistDownloadedError = function(error,params){
        self.log("Problem downloading or unzipping playlist data : ");
        self.notifyError(self.ERROR['TRANSFER_SERVICE']+4,self.name+": Function onPlaylistDownloadedError() failed : Problem downloading or unzipping playlist data file ");
        self.log(error);
    };

    this.library = function(){
        clearTimeout(self.library_timer)
        self.library_timer = setTimeout(self.library,self.library_interval);
        if(self.internet_connected && self.started && !self.OS.busy){
            var actual_library = self.file_manager.library.length;
            //self.notifyError(self.ERROR['TRANSFER_SERVICE']+5,self.name+": Function library() : internet connection OK ");
            self.log("# Library beat ... "+actual_library);
            var internet_is_really_available = self.OS.internetConnected();
            if(internet_is_really_available){
              self.log("Real Internet Connection Found - Downloading pending files ...");
              self.file_manager.downloadPendingFilesInArchive(true);
            }else{
              self.log("NO Real Internet Connection Found - Avoiding downloading files");
            }
            if(actual_library != self.file_manager.lastLibraryCount && self.file_manager.initiated){
                var data = {
                    id: self.core_id,
                    videos : self.file_manager.library
                }
                self.api_connector.post(self.api_url,self.api_ver,"player/library",data,self.libraryResponse,actual_library);
                self.log("# Notifing Library Changes ...");
            }else{
                self.log("# No Changes on Library.");
            }
        }else{
            self.log("# Library beat ...  started: "+self.started+" internet : "+self.internet_connected);
            //self.notifyError(self.ERROR['TRANSFER_SERVICE']+6,self.name+": Function library() :  started: "+self.started+" internet : "+self.internet_connected);
        }
    };

    this.libraryResponse = function(response,status,params){
        if(status == "success"){
            self.file_manager.lastLibraryCount = params;
        }
        self.log("Library response status : "+status+" | "+response);
    };

    this.check_errors = function(){
        clearTimeout(self.errors_timer);
        self.errors_timer = setTimeout(self.check_errors,self.errors_interval);
        if(self.license.registered && !self.OS.busy){
            if(!self.reading_errors){
                self.reading_errors = true;
                self.log("Check log/errors ... read directory");
                try{
                    self.OS.readDirectory(self.ROUTES['LOG'].path,self.errorsList);
                }
                catch(e){
                    self.log(e)
                    self.reading_errors = false;
                }

            }
        }
    };

    this.errorsList = function(files){
        if(typeof(files) !== "undefined"){
            var errorFiles = [];
            var check_file = null;
            var check_file_extension = null;
            for(var i=0;i<files.length;i++){
                check_file = null;
                check_file = files[i];
                if(typeof(check_file) !== "undefined"){
                    if(check_file != ""){
                        if(self.platform == "SOC"){
                            check_file = check_file.substring(2,check_file.length-1);
                        }
                        check_file_extension = null;
                        check_file_extension = check_file.substring(check_file.lastIndexOf('.'),check_file.length);
                        if(check_file_extension == ".err"){
                            errorFiles.push(check_file);
                        }
                    }
                }
            }

            if(errorFiles.length > 0){
                var error_file = errorFiles[errorFiles.length-1];
                if(typeof(error_file) !== "undefined"){
                    if(error_file != ""){
                        var extension = error_file.substring(error_file.lastIndexOf('.'),error_file.length);
                        if(extension == ".err"){
                            self.log("Check log/errors ... reading file : "+error_file);
                            self.OS.checkSize(self.ROUTES['LOG'].path+error_file, function(deleteFile){
                                if(deleteFile){
                                    self.OS.deleteFile(self.ROUTES['LOG'].path+error_file);
                                    self.reading_errors = false;
                                }
                                else{
                                    self.OS.readFile(self.ROUTES['LOG'].path+error_file,function(data,file_ref,params){
                                        var dataJSON = {};
                                        try{
                                            dataJSON = JSON.parse(data);
                                            var timestamp = parseInt(self.getDate().getTime()/1000);
                                            var post_data = "id="+self.core_id+"&tstamp="+timestamp+"&error=0&message="+JSON.stringify(dataJSON);
                                            self.api_connector.post(self.api_url,self.api_ver,"player/errors",post_data,self.errorsResponse,{filename:""+error_file});
                                        }catch(e){
                                            self.log("Problem reading error data ... avoid : "+e.message);
                                            self.OS.deleteFile(self.ROUTES['LOG'].path+error_file);
                                            self.reading_errors = false;
                                        }
                                    });
                                }
                            })

                        }else{
                            self.log("Check log/errors ... bad extension : "+error_file);
                            self.reading_errors = false;
                        }
                    }else{
                        self.log("Check log/errors ... no valid file: ");
                        self.reading_errors = false;
                    }
                }else{
                    self.log("Check log/errors ... could not read dir");
                    self.reading_errors = false;
                }
            }else{
                self.log("Check log/errors ... dir is empty");
                self.reading_errors = false;
            }
            errorFiles = null;
        }
    };

    this.errorsResponse = function(response,status,params){
        self.log("Send system errors response with status : "+status+" and response : "+response);
        self.OS.deleteFile(self.ROUTES['LOG'].path+params["filename"],function(ok,filename,params){
            self.reading_errors = false;
            if(ok){
                self.OS.readDirectory(self.ROUTES['LOG'].path,self.errorsList);
            }
        });
    };

    this.live = function(){
        if(self.no_screenShot == false || self.no_screenShot == "false"){
            if(self.live_interval != null && self.live_interval != "null"){
                self.log("# Live beat ... with interval : "+self.live_interval);
                clearTimeout(self.live_timer);
                self.live_timer = setTimeout(self.live,self.live_interval);
                if(!self.OS.busy){
                  self.OS.takeScreenshot(self.onNewScreenshot);
                }
            }
            else{
                self.log("# Live not beat ... no_screenShot is "+self.no_screenShot+ "  and live_interval is "+ self.live_interval);
                clearTimeout(self.live_timer);
            }
        }
        else{
            self.log("# Live not beat ... no_screenShot is "+self.no_screenShot);
            clearTimeout(self.live_timer);
        }
    };

    this.onNewScreenshot = function(base64Image,params){
        self.log("Screenshot created ... ready to send.");
        self.screenshot = base64Image;
        self.screenshot2 = base64Image;
    };

    this.serverDateTimeResponse = function(response,status){
        if(status == "success"){
            var bad_date = false;

            var data = ""+response;
            var data_array = data.split(":");
            var localDate = parseInt(new Date().getTime()/1000);
            if(self.platform == "SOC"){
                var time_api = document.getElementById('timePlugin');
                time_api.Open('Time', '1.000', 'Time');
                var soc_timestamp = time_api.Execute('GetEpochTime');
                time_api.Close();
                time_api = null;
                localDate = parseInt(soc_timestamp);
            }
            self.log("Localtime : ["+localDate+"]");
            var serverDate = parseInt(data_array[0]);
            self.log("Servertime : ["+serverDate+"]");
            var timezoneOffset = parseInt(data_array[1]);
            self.log("TimezoneOffset : ["+timezoneOffset+"]");
            var offset = localDate - serverDate;
            self.log("Local offset : ["+offset+"]");
            var new_timestamp = parseInt(localDate+(offset*-1)+(timezoneOffset*-1));
            self.log("New timestamp : ["+new_timestamp+"]");
            var futureTimezoneChange = parseInt(data_array[2]);
            var futureTimezoneOffset = parseInt(data_array[3]);

            // 48h = 172800 secs // check invalid datetimes.
            self.log(localDate+" > "+(serverDate - 172800)+" || "+localDate+" < "+(serverDate + 172800));

            if(localDate > (serverDate - 172800) && localDate < (serverDate + 172800)){
                self.log("Time is GOOD !");
                self.timeCheckRetries = 0;
                self.timeChecked = true;
            }else{
                self.log("Not good datetime yet with retries : "+self.timeCheckRetries);
                self.timeChecked = false;
                if(self.timeCheckRetries > 5){
                    if(self.platform == "SOC"){
                        self.OS.readFile(self.ROUTES['REBOOT'].path,function(value,file_ref,params){
                            if(value != ""){
                                try{
                                    if(value.length > 0){
                                        var reboots = parseInt(value);
                                        if(reboots < 5){
                                            self.OS.writeFile(self.ROUTES['REBOOT'].path,(reboots+1),function(ok,file_ref,params){
                                                self.notifyError(self.ERROR['TRANSFER_SERVICE']+17,self.name+": Rebood required for SOC platform unable to set date.");
                                                setTimeout(function(){
                                                    self.OS.rebootSystem(self.platform);
                                                }, 10000);
                                            });
                                        }
                                        else{
                                            var ob='<img  width="1920" height="1080" src="'+self.ROUTES['STYLE'].path+'"contactTechnicalSupport.jpg">';
                                            document.getElementById("emergency").innerHTML=ob;
                                        }
                                    }
                                    else{
                                        self.OS.writeFile(self.ROUTES['REBOOT'].path,1,function(ok,file_ref,params){
                                            self.notifyError(self.ERROR['TRANSFER_SERVICE']+17,self.name+": Rebood required for SOC platform unable to set date.");
                                            setTimeout(function(){
                                                self.OS.rebootSystem(self.platform);
                                            }, 10000);
                                        });
                                    }
                                }catch(e){
                                    self.notifyError(self.ERROR['TRANSFER_SERVICE']+17,self.name+": Reboot required for SOC platform unable to set date.");
                                    setTimeout(function(){
                                        self.OS.rebootSystem(self.platform);
                                    }, 10000);
                                }
                            }
                            else{
                                self.OS.writeFile(self.ROUTES['REBOOT'].path,1,function(ok,file_ref,params){
                                    self.notifyError(self.ERROR['TRANSFER_SERVICE']+17,self.name+": Rebood required for SOC platform unable to set date.");
                                    setTimeout(function(){
                                        self.OS.rebootSystem(self.platform);
                                    }, 10000);
                                });
                            }
                        });
                    }
                }else{
                    self.timeCheckRetries++;
                    if(self.platform == "SOC"){
                        self.OS.readFile(self.ROUTES['REBOOT'].path,function(value,file_ref,params){
                            if(value != ""){
                                try{
                                    if(value.length > 0){
                                        var reboots = parseInt(value);
                                        if(reboots < 5){
                                            self.OS.writeFile(self.ROUTES['REBOOT'].path,(reboots+1),function(ok,file_ref,params){
                                                self.notifyError(self.ERROR['TRANSFER_SERVICE']+17,self.name+": Rebood required for SOC platform unable to set date.");
                                                setTimeout(function(){
                                                    self.OS.rebootSystem(self.platform);
                                                }, 10000);
                                            });
                                        }
                                        else{
                                            var ob='<img  width="1920" height="1080" src="'+self.ROUTES['STYLE'].path+'"contactTechnicalSupport.jpg">';
                                            document.getElementById("emergency").innerHTML=ob;
                                        }
                                    }
                                    self.OS.writeFile(self.ROUTES['REBOOT'].path,1,function(ok,file_ref,params){
                                        self.notifyError(self.ERROR['TRANSFER_SERVICE']+17,self.name+": Rebood required for SOC platform unable to set date.");
                                        setTimeout(function(){
                                            self.OS.rebootSystem(self.platform);
                                        }, 10000);
                                    });
                                }catch(e){
                                    console.log(e);
                                    self.OS.writeFile(self.ROUTES['REBOOT'].path,1,function(ok,file_ref,params){
                                        self.notifyError(self.ERROR['TRANSFER_SERVICE']+17,self.name+": Rebood required for SOC platform unable to set date.");
                                        setTimeout(function(){
                                            self.OS.rebootSystem(self.platform);
                                        }, 10000);
                                    });
                                }
                            }
                            else{
                                self.OS.writeFile(self.ROUTES['REBOOT'].path,1,function(ok,file_ref,params){
                                    self.notifyError(self.ERROR['TRANSFER_SERVICE']+17,self.name+": Rebood required for SOC platform unable to set date.");
                                    setTimeout(function(){
                                        self.OS.rebootSystem(self.platform);
                                    }, 10000);
                                });
                            }
                        });
                    }
                }
            }
            //if(!self.timeChecked){
                if(isNaN(localDate)){
                    self.notifyError(self.ERROR['TRANSFER_SERVICE']+7,self.name+": Function serverDateTimeResponse() : localDate is NaN : "+localDate);
                    bad_date = true;
                }else if(localDate >= 2106345600){
                    localDate = 1856610740; // HARD SET Tue Oct 31 2028 14:12:20 GMT+0100 (CET)
                    self.notifyError(self.ERROR['TRANSFER_SERVICE']+14,self.name+": Function serverDateTimeResponse() : date is in a invalid Future .. HARD SET Tue Oct 31 2028 14:12:20  : "+localDate);
                }

                if(isNaN(serverDate)){
                    self.notifyError(self.ERROR['TRANSFER_SERVICE']+8,self.name+": Function serverDateTimeResponse() : localDate is NaN : "+serverDate);
                    bad_date = true;
                }

                if(isNaN(timezoneOffset)){
                    self.notifyError(self.ERROR['TRANSFER_SERVICE']+9,self.name+": Function serverDateTimeResponse() : timezoneOffset is NaN "+timezoneOffset);
                    bad_date = true;
                }

                if(isNaN(new_timestamp)){
                    self.notifyError(self.ERROR['TRANSFER_SERVICE']+10,self.name+": Function serverDateTimeResponse() : new_timestamp is NaN : "+new_timestamp);
                    bad_date = true;
                }

                if(isNaN(futureTimezoneChange)){
                    self.notifyError(self.ERROR['TRANSFER_SERVICE']+11,self.name+": Function serverDateTimeResponse() : futureTimezoneChange is NaN : "+futureTimezoneChange);
                    //bad_date = true;
                    futureTimezoneChange = 0;
                }

                if(isNaN(futureTimezoneChange)){
                    self.notifyError(self.ERROR['TRANSFER_SERVICE']+12,self.name+": Function serverDateTimeResponse() : futureTimezoneOffset is NaN : "+futureTimezoneOffset);
                    //bad_date = true;
                    futureTimezoneOffset = 0;
                }

                if(!bad_date){
                    self.OS.setSystemDateTime(new_timestamp,function(ok){
                        if(ok){
                            self.notifyError(self.ERROR['TRANSFER_SERVICE']+13,self.name+": Function serverDateTimeResponse() : Device Set Time Completed OK");
                            self.setServerTimeParams(localDate*1000,
                                             serverDate*1000,
                                             timezoneOffset*1000,
                                             futureTimezoneChange*1000,
                                             futureTimezoneOffset*1000);
                            //$(self).trigger("SystemTimeUpdate",[before,after]);


                            // THIS ONLY WORKS ON NONE SEPARATED TRANSFER !!!!! (will work on soc, android, ios, ... but not on nwjs for example ... )

                            if(self.setTimeCallback){
                                self.setTimeCallback(localDate*1000,
                                                     serverDate*1000,
                                                     timezoneOffset*1000,
                                                     futureTimezoneChange*1000,
                                                     futureTimezoneOffset*1000);
                            }

                        }else{
                            self.notifyError(self.ERROR['TRANSFER_SERVICE']+13,self.name+": Function serverDateTimeResponse() : Impossible to set time for device ... retry");
                        }
                    });
                }else{
                     self.notifyError(self.ERROR['TRANSFER_SERVICE']+13,self.name+": Function serverDateTimeResponse() : bad date - not using serverTime ... ");
                }
            //}
        }
    };



}
TransferService.prototype = new BasicService();
